/***** the library wide include file *****/
#include "liblfds_internal.h"

/***** defines *****/
#define FREELIST_POINTER 0
#define FREELIST_COUNTER 1
#define FREELIST_PAC_SIZE 2

#define FREELIST_DEBUG_POP  0
#define FREELIST_DEBUG_PUSH 1

/***** incomplete types *****/
struct freelist_element;

/***** structures *****/
#pragma pack( push, 16 )

struct freelist_element
{
  volatile struct freelist_element
    *next[FREELIST_PAC_SIZE];

  void
    *user_data;
};

struct freelist_state
{
  volatile struct freelist_element
    *top[FREELIST_PAC_SIZE];

  int
    (*user_data_init_function)( void **user_data, void *user_state );

  void
    *user_state;

  atom_t
    element_count;
};

#pragma pack( pop )

/***** private prototypes *****/
atom_t freelist_internal_new_element( struct freelist_state *fs, void **freelist_element );

