/***** the library wide include file *****/
#include "liblfds_internal.h"

/***** pragmas *****/

/***** defines *****/
#define FIFO_STATE_UNKNOWN               -1
#define FIFO_STATE_EMPTY                  0
#define FIFO_STATE_ENQUEUE_OUT_OF_PLACE   1
#define FIFO_ATTEMPT_DEQUEUE              2

#define QUEUE_POINTER 0
#define QUEUE_COUNTER 1
#define QUEUE_PAC_SIZE 2

/***** incomplete types *****/
struct queue_element;

/***** structures *****/
#pragma pack( push, 16 )

struct queue_state
{
  volatile struct queue_element
    *enqueue[QUEUE_PAC_SIZE],
    *dequeue[QUEUE_PAC_SIZE];

  void
    *freelist_state;
};

struct queue_element
{
  volatile struct queue_element
    *next[QUEUE_PAC_SIZE];

  void
    *freelist_element,
    *user_data;
};

#pragma pack( pop )

/***** externs *****/

/***** private prototypes *****/
int queue_internal_freelist_init_function( void **user_data, void *user_state );
void queue_internal_freelist_delete_function( void *user_data, void *user_state );

void queue_internal_new_element_from_freelist( struct queue_state *qs, volatile struct queue_element *qe[QUEUE_PAC_SIZE], void *user_data );
void queue_internal_guaranteed_new_element_from_freelist( struct queue_state *qs, volatile struct queue_element *qe[QUEUE_PAC_SIZE], void *user_data );
void queue_internal_init_element( volatile struct queue_element *qe[QUEUE_PAC_SIZE], void *freelist_element, void *user_data );

void queue_internal_queue( struct queue_state *qs, volatile struct queue_element *qe[QUEUE_PAC_SIZE] );

