/***** the library wide include file *****/
#include "liblfds_internal.h"

/***** pragmas *****/

/***** defines *****/
#define STACK_POINTER 0
#define STACK_COUNTER 1
#define STACK_PAC_SIZE 2

/***** incomplete types *****/
struct stack_element;

/***** structures *****/
#pragma pack( push, 16 )

struct stack_state
{
  // TRD : must come first for alignment
  volatile struct stack_element
    *top[STACK_PAC_SIZE];

  void
    *freelist_state;
};

struct stack_element
{
  volatile struct stack_element
    *next[STACK_PAC_SIZE];

  void
    *freelist_element,
    *user_data;
};

#pragma pack( pop )

/***** private prototypes *****/
int stack_internal_freelist_init_function( void **user_data, void *user_state );
void stack_internal_freelist_delete_function( void *user_data, void *user_state );

void stack_internal_new_element_from_freelist( struct stack_state *ss, volatile struct stack_element *se[STACK_PAC_SIZE], void *user_data );
void stack_internal_new_element( struct stack_state *ss, volatile struct stack_element *se[STACK_PAC_SIZE], void *user_data );
void stack_internal_init_element( volatile struct stack_element *se[STACK_PAC_SIZE], void *freelist_element, void *user_data );

void stack_internal_push( struct stack_state *ss, volatile struct stack_element *se[STACK_PAC_SIZE] );

